Attribute VB_Name = "POSTNET_PLANET"
' VB / VBA Functions for POSTNET/PLANET
' Copyright 2004 by MW6 Technologies Inc. All rights reserved.
'
' This code may not be modified or distributed unless you purchase
' the license from MW6.

Private I As Integer
Private StrLen As Integer
Private Sum As Integer
Private CurrChar  As Integer
Private Message As String

Public Function Encode(ByVal Src As String) As String
    StrLen = Len(Src)
    Sum = 0
    
    ' start character plus data
    Message = "*" & Src
    For I = 1 To StrLen
        Sum = Sum + Asc(Mid(Src, I, 1)) - Asc("0")
    Next I
    
    ' add CheckDigit
    Sum = Sum Mod 10
    If (Sum <> 0) Then
        Sum = 10 - Sum
    End If
    Message = Message & Chr(Sum + Asc("0"))
    
    ' add stop character
    Message = Message & "*"
    
    Encode = Message
End Function
